/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>
#include <stream.h>
#include <fcntl.h>
#include <unistd.h>
#include "oo7.h"
#include "baidlist.h"

// Add a Base assembly reference to a list 

void BAIdList::insert(Link<BaseAssembly> value)
{
    BAListElem* elem = new BAListElem;

    if (elem == NULL) 
    {
	printf("new failed in BAIdlist.insert()\n");
	return;
    }
    elem->ba = value;
    elem->next = listPtr;
    listPtr = elem;
}

// initialize a scan
void BAIdList::initScan()
{
    current = listPtr;
}

// Scan 
Link<BaseAssembly> BAIdList::next()
{
    if (current == NULL) return NULL;
    else
    {
	Link<BaseAssembly>	baseAssembly = current->ba;

	current = current->next;
	return baseAssembly;    
    }
}
