/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

// structure for keeping track of a list of base assemblies
// that reference a composite part as either a shared or private member

class BAListElem
{
public:
    Link<BaseAssembly>	ba;
    BAListElem*		next;
};

class BAIdList
{
private:
    BAListElem* listPtr;
    BAListElem* current;

public:

    BAIdList();

    void insert(Link<BaseAssembly> value); // insert a new BA identifier in list

    Link<BaseAssembly> next(); // scan list returning all elements

    void  initScan(); // scan list returning all elements
};

inline
BAIdList::BAIdList() : listPtr(NULL), current(NULL)
{
}
